# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence
stages:
- test
- lint
- docker

sast:
  stage: test
include:
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml

theme.js:
  image: node:latest
  stage: lint
  script:
  - npm install -g eslint
  - eslint --init
  - eslint ./scripts/theme.js
dashboard.js:
  image: node:latest
  stage: lint
  script:
  - npm install -g eslint
  - eslint --init
  - eslint ./scripts/dashboard.js
utils.js:
  image: node:latest
  stage: lint
  script:
  - npm install -g eslint
  - eslint --init
  - eslint ./scripts/utils.js
uptime.js:
  image: node:latest
  stage: lint
  script:
  - npm install -g eslint
  - eslint --init
  - eslint ./scripts/uptime.js

build-and-publish:
  stage: docker
  image: docker:latest
  needs:
  - theme.js
  - dashboard.js
  - utils.js
  - uptime.js
  services:
  - docker:dind
  before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  script:
  - docker build --pull -t "$CI_REGISTRY_IMAGE" .
  - docker push "$CI_REGISTRY_IMAGE"
  only:
  - master
